<?php

include "LaMetricIP.php";

$apikey = "dev:" . $apikey;
$apikey = base64_encode($apikey);

if(isset($_REQUEST['text']))
{ 
    send_notification(); 
} 
elseif (isset($_REQUEST['delete']))
{
	delete_notifications();
}
else exit();

function send_notification() {

    global $apikey, $ip, $port;
    
    $url = "http://" . $ip . ":" . $port . "/api/v2/device/notifications";

    if(!isset($_REQUEST['priority']) || $_REQUEST['priority']=='')
        { $priority = "info"; } 
    else 
        { $priority = $_REQUEST['priority']; } 

    if(!isset($_REQUEST['icon_type']) || $_REQUEST['icon_type']=='')
        { $icon_type = "none"; } 
    else 
        { $icon_type = $_REQUEST['icon_type']; }

    if(!isset($_REQUEST['cycles']) || $_REQUEST['cycles']=='')
        { $cycles = "1"; } 
    else 
        { $cycles = $_REQUEST['cycles']; }
    
    if(!isset($_REQUEST['lifetime']) || $_REQUEST['lifetime']=='')
        { $lifetime = "120000"; } 
    else 
        { $lifetime = $_REQUEST['lifetime']; 
        $lifetime = $lifetime * 1000;
        }
    
    if(!isset($_REQUEST['icon']) || $_REQUEST['icon']=='')
        { $icon = ""; } 
    else 
        { $icon = $_REQUEST['icon']; }
    
    if(!isset($_REQUEST['text']) || $_REQUEST['text']=='')
        { $text = "Nachricht"; } 
    else 
        { $text = $_REQUEST['text']; }
 
    if(!isset($_REQUEST['category']) || $_REQUEST['category']=='')
        { $category = "notifications"; } 
    else 
        { $category = $_REQUEST['category']; }

    if(!isset($_REQUEST['id']) || $_REQUEST['id']=='')
        { $id = ""; } 
    else 
        { $id = $_REQUEST['id']; }

    if(!isset($_REQUEST['repeat']) || $_REQUEST['repeat']=='')
        { $repeat = "1"; } 
    else 
        { $repeat = $_REQUEST['repeat']; }
     
    
    if ($id != "") {
        $message_construct = array(
            "lifetime" => "$lifetime",
            "priority" => "$priority",
            "icon_type" => "$icon_type",
            "model" => array(
                "cycles" => (int)$cycles,
                "frames" => array(
                    array(
                        "icon" => "$icon",
                        "text" => "$text"
                    )
        		),
        		"sound" => array (
        			"category" => "$category",
        			"id" => "$id",
        			"repeat" => (int)$repeat
        			)
        		
         	)
        );
    }

    else 

    {  
        $message_construct = array(
            "lifetime" => "$lifetime",
            "priority" => "$priority",
            "icon_type" => "$icon_type",
            "model" => array(
                "cycles" => (int)$cycles,
                "frames" => array(
                    array(
                        "icon" => "$icon",
                        "text" => "$text"
                    )
                ),
            )
        );
    }

     
    $curl = curl_init();
     
    $headers = array(
        "Accept: application/json",
        "Content-Type: application/json",
        "Authorization: Basic $apikey", 
        "Cache-Control: no-cache", 
    );
     
    curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
    curl_setopt($curl, CURLOPT_URL, $url); 
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1); 
    curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
    curl_setopt($curl, CURLOPT_HTTPHEADER, $headers); 
    curl_setopt($curl, CURLOPT_POST, 1); 
    curl_setopt($curl, CURLOPT_POSTFIELDS, json_encode($message_construct)); 
     
    $response = curl_exec($curl);
     
    echo $response;
     
    curl_close($curl);
}


function delete_notifications() {

    global $apikey, $ip, $port;
    
    $url = "http://" . $ip . ":" . $port . "/api/v2/device/notifications";

    $delete = $_REQUEST['delete'];
    
    $curl = curl_init();
     
    $headers = array(
        "Accept: application/json",
        "Content-Type: application/json",
        "Authorization: Basic $apikey", 
        "Cache-Control: no-cache", 
    );

    curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
    curl_setopt($curl, CURLOPT_URL, $url); 
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1); 
    curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
    $queue = curl_exec($curl);
    curl_close($curl);

    $queue = json_decode($queue);


    if ($delete == 'all') {

        foreach (array_reverse($queue) as $key) {
            $t_url = $url;
            $id = $key->id;
            echo $id;
            $t_url = $t_url . "/" . $id;
            $curl = curl_init();
             
            $headers = array(
                "Accept: application/json",
                "Content-Type: application/json",
                "Authorization: Basic $apikey", 
                "Cache-Control: no-cache", 
            );
              
            curl_setopt($curl, CURLOPT_CUSTOMREQUEST, "DELETE");
            curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
            curl_setopt($curl, CURLOPT_URL, $t_url); 
            curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1); 
            curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
            $response = @curl_exec($curl);
            curl_close($curl);
        }
	}

	elseif ($delete == 'current') {
		
		if (array_keys($queue)) {	
			$id = $queue[0]->id;
			$t_url = $url;
	            
	        $t_url = $t_url . "/" . $id;
	        $curl = curl_init();
	         
	        $headers = array(
	            "Accept: application/json",
	            "Content-Type: application/json",
	            "Authorization: Basic $apikey", 
	            "Cache-Control: no-cache", 
	        );
	          
	        curl_setopt($curl, CURLOPT_CUSTOMREQUEST, "DELETE");
	        curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
	        curl_setopt($curl, CURLOPT_URL, $t_url); 
	        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1); 
	        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
	        $response = @curl_exec($curl);
	        curl_close($curl);
	   	}
    }
}

?>